<?php
/*
	Copyright(c) 2011 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once LIB_PATH.'/common/unitCommon.php';

class extBgScroll extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "unit_multiple_data"; 		//公開用テーブル名
	var $_tmptable = "unit_multiple_data_tmp";	//下書き用テーブル名
	var $_unit_dir = "extBgScroll";
	var $columns = array(
    array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット個別ID
    array("column"=>"pageu_unit_code","conv"=>"n","tags"=>false),	//ユニット個別ID
    array("column"=>"pageu_unit_name","conv"=>"Kva","tags"=>false),	//ユニット個別ID
    array("column"=>"mlt_data1","conv"=>"Kva","tags"=>false),	//データ1
    array("column"=>"mlt_data2","conv"=>"Kva","tags"=>true),	//データ2
    array("column"=>"mlt_data3","conv"=>"Kva","tags"=>false),	//データ3
    array("column"=>"mlt_data4","conv"=>"Kva","tags"=>false),	//データ4
    array("column"=>"mlt_data5","conv"=>"Kva","tags"=>false),	//データ5
    array("column"=>"mlt_data6","conv"=>"Kva","tags"=>false),	//データ6
    array("column"=>"mlt_data7","conv"=>"Kva","tags"=>false),	//データ7
    array("column"=>"mlt_data8","conv"=>"Kva","tags"=>false),	//データ8
    array("column"=>"mlt_data9","conv"=>"Kva","tags"=>false),	//データ9
    array("column"=>"mlt_data10","conv"=>"Kva","tags"=>false),	//データ10
    array("column"=>"mlt_data11","conv"=>"Kva","tags"=>false),	//データ11
    array("column"=>"mlt_data12","conv"=>"Kva","tags"=>false),	//データ12
    array("column"=>"mlt_data13","conv"=>"Kva","tags"=>false),	//データ13
    array("column"=>"mlt_data14","conv"=>"Kva","tags"=>false),	//データ14
    array("column"=>"mlt_data15","conv"=>"Kva","tags"=>false),	//データ15
    array("column"=>"mlt_data16","conv"=>"Kva","tags"=>false),	//データ16
    array("column"=>"mlt_data17","conv"=>"Kva","tags"=>false),	//データ17
    array("column"=>"mlt_data18","conv"=>"Kva","tags"=>false),	//データ18
    array("column"=>"mlt_data19","conv"=>"Kva","tags"=>false),	//データ19
    array("column"=>"mlt_data20","conv"=>"Kva","tags"=>false),	//データ20
    array("column"=>"mlt_data21","conv"=>"Kva","tags"=>false),	//データ21
    array("column"=>"mlt_data22","conv"=>"Kva","tags"=>false),	//データ22
    array("column"=>"mlt_data23","conv"=>"Kva","tags"=>false),	//データ23
    array("column"=>"mlt_data24","conv"=>"Kva","tags"=>false),	//データ24
    array("column"=>"mlt_data25","conv"=>"Kva","tags"=>false),	//データ25
    array("column"=>"mlt_data26","conv"=>"Kva","tags"=>false),	//データ26
    array("column"=>"mlt_data27","conv"=>"Kva","tags"=>false),	//データ27
    array("column"=>"mlt_data28","conv"=>"Kva","tags"=>false),	//データ28
    array("column"=>"mlt_data29","conv"=>"Kva","tags"=>false),	//データ29
    array("column"=>"mlt_data30","conv"=>"Kva","tags"=>false),	//データ30 
    array("column"=>"mlt_data31","conv"=>"Kva","tags"=>false),	//データ31
    array("column"=>"mlt_data32","conv"=>"Kva","tags"=>false),	//データ32
    array("column"=>"mlt_data33","conv"=>"Kva","tags"=>false),	//データ33
    array("column"=>"mlt_data34","conv"=>"Kva","tags"=>false),	//データ34
    array("column"=>"mlt_data35","conv"=>"Kva","tags"=>false),	//データ35
    array("column"=>"mlt_data36","conv"=>"Kva","tags"=>false),	//データ36
    array("column"=>"mlt_data37","conv"=>"Kva","tags"=>false),	//データ37
    array("column"=>"mlt_data38","conv"=>"Kva","tags"=>false),	//データ38
    array("column"=>"mlt_data39","conv"=>"Kva","tags"=>false),	//データ39
    array("column"=>"mlt_data40","conv"=>"Kva","tags"=>false),	//データ40
    array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
    array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
    array("column"=>"btm_padding","conv"=>"n","tags"=>false),	//下方スペース
    array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
    array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
    array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),	//下方スペース
    array("column"=>"use_pc_flg","conv"=>"n","tags"=>false),	//PCフラグ
    array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)	//スマホフラグ
  );
  
  var $column_link=array(
    1=>"bg_height"
    ,2=>"bg_img_code"
    ,3=>"bg_img_path"
    ,4=>"bg_img_width"
    ,5=>"bg_img_height"
    ,6=>"bg_img_mime"
    ,7=>"bg_img_initial_y"
    ,8=>"bg_img_facter"
    ,9=>"bg_img_reverse"
    ,10=>"bg_height_sp"
    ,11=>"bg_img_start"
    ,12=>"bg_img_height_sp"
    ,13=>"bg_img_initial_y_sp"
    ,14=>"bg_title"
    ,15=>"bg_title_tag"
    ,16=>"bg_title_color"
    ,17=>"bg_title_size"
    ,18=>"bg_title_size_sp"
    ,19=>"anchor_text"
  );

	//▼変数宣言///////////////////
	var $_data;
  var $_fonts=array(
    null=>'---',
    'Tangerine'=>'Tangerine',
    'Mr Dafoe'=>'MrDafoe',
    'Dancing Script'=>'Dancing',
    'Playball'=>'Playball',
    'Lato'=>'Lato',
    'Playfair Display'=>'Playfair',
    'PT Sans'=>'PTsans',
    'Roboto'=>'Roboto',
    'Lora'=>'Lora',
    'Muli'=>'Muli',
    'Open Sans'=>'OpenSans',
    'League Script'=>'League'
  );
	//▲変数宣言///////////////////
	
	function bSuperUnit()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
    if(!class_exists("imgmngrDB")){
      include LIB_PATH."/common/imgmngrDB.php";
    }
    $this->_data = $this->getDetail();

		//▼データ操作  ////////
		if($this->_data!=null){
      if(defined("SP_FLG") && SP_FLG==SP_FLG_CODE){
        //レイアウト
				if(is_numeric($this->_data["bg_color_sp"])) $this->_data["bg_color"] = $this->_data["bg_color_sp"];
				if(is_numeric($this->_data["bdr_type_sp"])) $this->_data["bdr_type"] = $this->_data["bdr_type_sp"];
				if(is_numeric($this->_data["btm_padding_sp"])) $this->_data["btm_padding"] = $this->_data["btm_padding_sp"];
        
        if(is_numeric($this->_data["bg_height_sp"])) $this->_data["bg_height"] = $this->_data["bg_height_sp"];
        if(is_numeric($this->_data["bg_img_initial_y_sp"])) $this->_data["bg_img_initial_y"] = $this->_data["bg_img_initial_y_sp"];
        if(!empty($this->_data["bg_title_size_sp"])) $this->_data["bg_title_size"] = $this->_data["bg_title_size_sp"];
			}      
      if(is_numeric($this->_data["bg_title_size"])) $this->_data["bg_title_size"] = $this->_data["bg_title_size"]."em";
		}

		//▲データ操作  ////////
		$this -> _view -> assign('pageu_code', $this->_pageu_code);
    $this -> _view -> assign('data', $this->_data);
    $this -> _view -> assign('ua', $this->_ua);        
    $this->_view->_tpl_vars["addLink"].='<link type="text/css" href="'.BINGOTOPURL.'/js/jquery.bingo/jquery.bbgscroll.css" rel="stylesheet" media="all" />';
    
		return $this->_data;
	}
  
	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if($result){
				$data = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $data = $this->replaceMultipleData($data, $this->column_link, "mlt_data");
			}
		}
		return $data;
	}


	function setDefault()
	{ 
		$this->_data = $this->getDetail();
    if(!$this->_data){
      $this->_data["bg_img_initial_y"] = 50;
      $this->_data["bg_img_initial_y_sp"] = 50;
      $this->_data["bg_img_facter"] = 0.1;
      $this->_data["bg_img_reverse"] = 0;
      $this->_data["bg_title_tag"] = 'h3';
    }else{
      if(is_numeric($this->_data["bg_title_size"])) $this->_data["bg_title_size"] = $this->_data["bg_title_size"]."em";
      if(is_numeric($this->_data["bg_title_size_sp"])) $this->_data["bg_title_size_sp"] = $this->_data["bg_title_size_sp"]."em";
    }
    $this->_view->assign("data", $this->_data);
		$this->_form->setDefaults($this->_data);
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
    
    //高さ
    $this->_form->addElement('text', 'bg_height', null, array('id'=>'bg_height', 'class'=>'num alpnum'));
    $this->_form->addElement('text', 'bg_height_sp', null, array('id'=>'bg_height_sp', 'class'=>'num alpnum'));
    //背景画像
    $this->_form->addElement('hidden', 'bg_img_code', null, array('id'=>'bg_img_code'));
    $this->_form->addElement('hidden', 'bg_img_path', null, array('id'=>'bg_img_path'));
    $this->_form->addElement('hidden', 'bg_img_width', null, array('id'=>'bg_img_width'));
    $this->_form->addElement('hidden', 'bg_img_height', null, array('id'=>'bg_img_height'));
    $this->_form->addElement('hidden', 'bg_img_mime', null, array('id'=>'bg_img_mime'));
    
    //開始位置
    $this->_form->addElement('text', 'bg_img_start', null, array('id'=>'bg_img_start', 'class'=>'num alpnum', 'placeholder'=>'0'));
    //初期位置%
    $this->_form->addElement('text', 'bg_img_initial_y', null, array('id'=>'bg_img_initial_y', 'class'=>'num alpnum', 'placeholder'=>'50'));
    $this->_form->addElement('text', 'bg_img_initial_y_sp', null, array('id'=>'bg_img_initial_y_sp', 'class'=>'num alpnum', 'placeholder'=>'50'));
    //速度係数
    $this->_form->addElement('text', 'bg_img_facter', null, array('id'=>'bg_img_facter', 'class'=>'num alpnum', 'placeholder'=>'0.1'));
    //移動方向
    $v = array(0=>'上へ移動', 1=>'下へ移動');
    $r = array();
    foreach($v as $k=>$v){
      $r[]=$this->_form->createElement('radio', null, null, $v, $k, array());
    }
    $this->_form->addGroup($r, 'bg_img_reverse', null, '&nbsp;&nbsp;');
    
    
    //タイトル
    $this->_form->addElement('textarea', 'bg_title', null, array('id'=>'bg_title', 'class'=>'num wl mgB5'));
    $this->_form->addElement('text', 'bg_title_color', null, array('id'=>'bg_title_color', 'class'=>'color'));
    $this->_form->addElement('text', 'bg_title_size', null, array('id'=>'bg_title_color', 'class'=>'num'));
    $this->_form->addElement('text', 'bg_title_size_sp', null, array('id'=>'bg_title_color', 'class'=>'num'));
    $this->_form->addElement('select', 'bg_title_tag', null, array('div'=>'div','h1'=>'h1','h2'=>'h2','h3'=>'h3','h4'=>'h4','h5'=>'h5','h6'=>'h6'), array('id'=>'bg_title_tag', 'class'=>'pulldown'));

    //アンカーテキスト
    $this->_form->addElement('text', 'anchor_text', null, array('id'=>'anchor_text'));
    
		$this -> _view -> assign("unit_dir",$this->_unit_dir);
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings('下記の項目が不正です。','');
		$this->_form->addRule('pageu_code','・「ユニットコード」が不明です。コンテンツ管理よりやり直してください','required',null,$this->erchk);
    
    $this->_form->registerRule("check_css_color", "regex", "/^#[0-9a-fA-F]{3}$|^#[0-9a-fA-F]{6}$/");
    $this->_form->registerRule("check_css_property", "regex", "/^\d+$|\d+(px|em|pt|%)$|^auto$/");
    $this->_form->registerRule("NumericRange", "callback", "NumericRange");
    
    $this->_form->addRule('bg_img_code', _gettext('B_P01029', '画像'),'required',null,$this->erchk);
    
    $this->_form->addRule('bg_height', _gettext('B_P01029', '高さ'),'required',null,$this->erchk);
    $this->_form->addRule('bg_height', _gettext('B_P01031', '高さ'),'numeric',null,$this->erchk);
    $this->_form->addRule('bg_height', _gettext('B_P01037', array('高さ', 10, 10000)),'NumericRange',array(10,10000),$this->erchk);
    $this->_form->addRule('bg_height_sp', _gettext('B_P01031', '高さ（スマートフォン）'),'numeric',null,$this->erchk);
    $this->_form->addRule('bg_height_sp', _gettext('B_P01037', array('高さ（スマートフォン）', 10, 10000)),'NumericRange',array(10,10000),$this->erchk);
    
    
    $this->_form->addRule('bg_img_initial_y', _gettext('B_P01031', '画像表示初期位置'),'numeric',null,$this->erchk);
    $this->_form->addRule('bg_img_initial_y', _gettext('B_P01037', array('画像表示初期位置', 0, 100)),'NumericRange', array(0,100),$this->erchk);
    $this->_form->addRule('bg_img_initial_y_sp', _gettext('B_P01031', '画像表示初期位置(スマートフォン)'),'numeric',null,$this->erchk);    
    $this->_form->addRule('bg_img_initial_y_sp', _gettext('B_P01037', array('画像表示位置(スマートフォン)', 0, 100)),'NumericRange', array(0,100),$this->erchk);
    
    $this->_form->addRule('bg_img_start', _gettext('B_P01031', '動作開始位置'),'numeric',null,$this->erchk);
    $this->_form->addRule('bg_img_start', _gettext('B_P01037', array('動作開始位置', -10000, 10000)),'NumericRange', array(-10000,10000),$this->erchk);
    
    $this->_form->addRule('bg_img_facter', _gettext('B_P01031', '速度係数'),'numeric',null,$this->erchk);
    $this->_form->addRule('bg_img_facter', _gettext('B_P01037', array('速度係数', 0, 10)),'NumericRange', array(0,10),$this->erchk);
    
    $this->_form->addRule('bg_title_size', _gettext('B_P00991', 'タイトルサイズ'),'check_css_property',null,$this->erchk);
    $this->_form->addRule('bg_title_size_sp', _gettext('B_P00991', 'タイトルサイズ(スマートフォン)'),'check_css_property',null,$this->erchk);
    $this->_form->addRule("bg_title_color", _gettext('B_P01027', 'タイトルの装飾（色）'), "check_css_color", null, "server");
		
	}

	//データ下書き保存処理
	function doSave($post)
	{
    include LIB_PATH."/common/imgmngrDB.php";
  
  
		if(!is_numeric($post['pageu_code'])){
			return "・データの保存に失敗しました";
		}       
    $post= $this->replaceMultipleData($post, $this->column_link, "mlt_data", true);
    //既存データがあるか確認
		$old_data = $this->getDetail();
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			}else{
        $record[$val["column"]] = null;
      }
		}
    $record["pageu_unit_code"] = $this->_unit_data["unit_code"];
    $record["pageu_unit_name"] = $this->_unit_data["unit_name"];
    
    //画像処理
    $cparr=array();
    //タイトル画像
    if($post["bg_img_del"] == 1){
      $record["mlt_data2"]=null;
      $record["mlt_data3"]=null;
      $record["mlt_data4"]=null;
      $record["mlt_data5"]=null;
      $record["mlt_data6"]=null;
    }else{
      if(is_numeric($record["mlt_data2"])) {	
        $post_img_data=$record["mlt_data2"];
        $old_img_data=null;
        if(!empty($old_data["mlt_data2"])){
          $old_img_data=$old_data["mlt_data2"];
        }
        //画像コードが違う時だけ処理
        $imginfo=null;
        if(!$old_img_data || ($old_img_data != $post_img_data)){
          $imgmngrDB = new imgmngrDB();
          $imgdata = $imgmngrDB->getImageFromCode($post_img_data, UNITS_IMG_PATH, $record["pageu_code"], 1);
          if(isset($imgdata)){
            $data_path = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
            $img_path = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
            $imginfo=getimagesize(BASE_PATH.$data_path);
            $record["mlt_data3"] = array_pop(explode('/',$img_path)); //保存ファイル名取得
            $record["mlt_data4"] = $imginfo[0];//width
            $record["mlt_data5"] = $imginfo[1];//height
            $record["mlt_data6"] = $imginfo['mime'];//mine
            $cparr[$data_path] = $img_path;
          }else{
            return _gettext('B_P00651');
          }
        }
      }
    }

		$this->db->query('BEGIN');
		//保存処理開始
    //基本データ
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		}

    //画像保存
    if(is_array($cparr)){
      foreach($cparr as $src=>$dist){
        if(!@copy(BASE_PATH.$src, BASE_PATH.$dist)){
          $this->db->query('ROLLBACK');
          return _gettext('B_P00650');
        } else {
          @chmod(BASE_PATH.$dist, 0666);
        }
      }
    }    

		$this -> db -> query("COMMIT");
		return null;
	}


	//公開処理
	function TmptoCommon($pageu_code, $db) {
		if(!parent::TmptoCommon($pageu_code, $db)){
      return false;
    }
    return true;
	}
  
  	/*
	 * ロールバック（下書きテーブルへ公開データをコピー）（共通）
	 * pageView.phpが呼びます、ロールバック、コミットはpageViewにて行うのでbooleanで返してください。
	 */
	function CommonToTmp($pageu_code,$db) {
    if(!parent::CommonToTmp($pageu_code, $db)){
      return false;
    }
		return true;
	}
  

	/*
	 * ユニット複製処理（共通）
	 * page-unitlayout.phpより呼ばれます
	 * トランザクション処理は呼び元で行います
	 * @param $pageu_code コピー元のコード
	 * @param $target_pageu_code コピー先のコード
	 */
	function unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy=false) {
		if(!parent::unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy)){
      return false;
    }
    return true;
	}
}
?>